/* note to myself: it's probably more efficient to use pref.getBranch() */

function pref_save() {
  prefService = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPref);

  var policies;

  try {
    policies = prefService.GetCharPref('capability.policy.policynames');

    if (this.enabled) {
   
      if (policies.search(/(?:^|\,)js_sites(?:$|\,)/) < 0) {
        policies = (policies.length > 0)?(policies+',js_sites'):'js_sites'
      }
      prefService.SetCharPref('capability.policy.js_sites.javascript.enabled', 'allAccess');
      prefService.SetCharPref('capability.policy.default.javascript.enabled', 'noAccess');
    } else {
      policies = policies.replace(/(?:^|\,)js_sites(?:$|\,)/,'')
      prefService.SetCharPref('capability.policy.default.javascript.enabled', 'allAccess');
    } // if
    prefService.SetCharPref('capability.policy.policynames', policies);

  } catch(e) {
    if (this.enabled) prefService.SetCharPref('capability.policy.policynames', 'js_sites');
  }

  s = '';
  for (i = 0; i < this.sites.length; i++) {
     s = s + this.sites[i] + ' ';
  }
  if (s.length) s = s.substr(0, s.length - 1);

  prefService.SetBoolPref('javascript.enabled',this.globalEnabled);
  prefService.SetCharPref('capability.policy.js_sites.sites', s);
}

function pref_add(newSite) {
   newSite = newSite.replace(/^www\./,'')
   for (i=0; i < this.sites.length; i++) {
      if (this.sites[i] == newSite) return false;
   }
   this.sites.push(newSite);
   return true;
}

function pref_remove(oldSite) {
   oldSite = oldSite.replace(/^www\./,'')
   for (i=0; i < this.sites.length; i++) {
      if (this.sites[i] == oldSite) {
        this.sites.splice(i,1);
        return true;
      }
   }
   return false;
}

function jsPref() {
  var prefService;
  prefService = Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPref);

  try {
    policies = prefService.GetCharPref('capability.policy.policynames');
    this.enabled = (policies.search(/(?:^|\,)js_sites(?:$|\,)/) >= 0)
  } catch (e) {
    this.enabled = false;
  }

  try {
    sites = prefService.GetCharPref('capability.policy.js_sites.sites');
    this.sites = sites.split(' ');
  } catch (e) {
    this.sites = new Array('mozilla.org','mozillazine.com');
  }

  try      { this.globalEnabled = prefService.GetBoolPref('javascript.enabled'); }
  catch(e) { this.globalEnabled = true; }

  this.save = pref_save;
  this.add = pref_add;
  this.remove = pref_remove;

  return this;
}

var jspref;
var console_is_open;

function win_init(){
  jspref = new jsPref();

  document.getElementById("jsDisabled").checked= !jspref.globalEnabled;
  document.getElementById("jsconEnabled").checked= jspref.enabled;

  list = document.getElementById("site-list");
  for (i=0; i< jspref.sites.length; i++) {
    site = jspref.sites[i];
    listitemnode = document.createElement("listitem");
    with (listitemnode) {
      setAttribute("id", "li-"+site);
      setAttribute("label", site);
    }
    list.appendChild(listitemnode);
  }
  console_is_open = true;
  win_updateGlobalEnabled();
}

function win_updateGlobalEnabled() {
/*
  val = (jspref.globalEnabled)?"true":"false";
  document.getElementById('site-list').disabled = val;
  document.getElementById('jsconEnabled').disabled = val;
*/
}

function win_globalEnable() {
  jspref.globalEnabled = !(document.getElementById('jsDisabled').checked);
  win_updateGlobalEnabled;
}

function win_add(site) {
  if (jspref.add(site)) {

    site = site.replace(/^www\./,'')
    list = document.getElementById("site-list");

    node = document.createElement("listitem");
    with (node) {
      setAttribute("id", "li-"+site);
      setAttribute("label", site);
    }
    list.appendChild(node);
  }
}

function win_remove(site){
  site = site.replace(/^www\./,'')
  if (jspref.remove(site)) {
    list = document.getElementById("site-list");
    node = document.getElementById("li-" + site);
    list.removeChild(node);
  }
}

function win_removeSelection(){
  list = document.getElementById("site-list");
  items = list.selectedItems;
  if (items.length > 0) win_remove(items[0].label);
}

function win_close(){
  console_is_open = false;
  window.close();
}

function win_commit() {
  jspref.save();
  console_is_open = false;
  window.close();
}

function addThisSite() {
   host = location.hostname;
   if ( (typeof(console_is_open) != 'undefined') && (console_is_open) ) {
     jsp = new jsPref();
     jsp.add(host);
     jsp.save();
   } else {
     win_add(host);
     jspref.save();
   }
}

function removeThisSite() {
   host = location.hostname;
   if ( (typeof(console_is_open) != 'undefined') && (console_is_open) ) {
     jsp = new jsPref();
     jsp.remove(host);
     jsp.save();
   } else {
     win_remove(host);
     jspref.save();
   }
}
function openJsConsole() {
  window.open("chrome://jscon/content/jsconPrefs.xul", "JsConsole", "chrome,top=100,left=100");
}